// Sonya Chen
//
// Based off of code made by: Brian Seney
//
// Display.cpp

#include "Display.h"
#include "GraphicsManager.h"
#include "WorldManager.h"


using namespace std;

// This function displays a string at position world_pos on the screen.
// If any of the individual drawCh calls fail, the function returns -1.
int display_string(string a_str, Position world_pos){
  GraphicsManager &graph_mgr = GraphicsManager::getInstance();
  WorldManager &wm = WorldManager::getInstance();
  
  for(int i = 0; i < a_str.size(); i++){
    if(graph_mgr.drawCh(Position(wm.getView().getCorner().getX() + i, wm.getView().getCorner().getY()), a_str[i] ) == 1) // modified so that it displays in the upper corner of the screen, not the world
      return -1;
  }

  return 0;
}
