// Cian Rice

#include "Door.h"
#include "ResourceManager.h"
#include "LogManager.h"

Door::Door(Position door_pos) {

  ResourceManager &rm = ResourceManager::getInstance();
	
  Sprite *p_temp_sprite;
  p_temp_sprite = rm.getSprite("door");
  
  LogManager &lm = LogManager::getInstance();
  
  if(!p_temp_sprite) {
    lm.writeLog("Door::Door(): Warning! Sprite '%s' not found", "door");
    return;
  }
  setSprite(p_temp_sprite, true);

  setPosition(door_pos);
  setType("Door");
  setSolid(true);
  setCentered(true);
}

Door::~Door()
{

}
