#ifndef __HERO_H__
#define __HERO_H__

#include "GameObject.h"
#include "EventKeyboard.h"
#include "EventCollision.h"
#include "Position.h"
#include "Score.h"
#include "Lives.h"

class Hero : public GameObject {

 protected:
  void kbd(EventKeyboard *keyboard_event);
  void move(int dx, int dy);
  void move();

  bool has_key;
  int height;
  int lives;
  int side; // Which side, hero was last facing
  int victory;
  
  bool double_jump; // Checks to see if hero can double jump
  bool can_double_jump;

  Position start_position;

  bool move_right;
  bool move_left;

  void death();
  void add_life(int life);
  void attack();

  Score *score_HUD;
  Lives *lives_HUD;
  
  void collision(EventCollision *p_collide);

 public:
  Hero(Position start_pos);
  ~Hero();
  int eventHandler(Event *e);
  void setScore(int point_count);
  Score* setScoreHUD(Score* new_score_HUD);
  void setLives(int life_count);
  Lives* setLivesHUD(Lives* new_lives_HUD);
  int getHeroLives();
  
};

#endif
