// Cian Rice

#include "Lives.h"

using namespace std;

Lives::Lives(Position hud_pos, int init_lives) {
	altitude = 2;
	setType("Lives HUD");
	setSolid(false);	
	LogManager &lm = LogManager::getInstance();
	lm.writeLog("Initiliazing Lives HUD");
	WorldManager &wm = WorldManager::getInstance();
	setPosition(hud_pos);
	pos.setY(pos.getY()+1);
	lm.writeLog("Second HUD X: = %d", pos.getX());
	lm.writeLog("Second HUD Y: = %d", pos.getY());
	wm.registerInterest(this, STEP_EVENT);
	lives = init_lives;

}

Lives::~Lives() {
	WorldManager &wm = WorldManager::getInstance();
	wm.registerInterest(this, STEP_EVENT);
}

// Code based upon Brian Seney's Saucer Shoot Score Code
void Lives::draw() {
  ostringstream hud(ostringstream::out);
  hud << "Lives: ";
  hud << lives;
  GraphicsManager &graph_mgr = GraphicsManager::getInstance();
  
  for(int i = 0; i < hud.str().size(); i++){
    if(graph_mgr.drawCh(Position(pos.getX() + i, 
		 pos.getY()), hud.str()[i]) == 1) // modified so that it displays in the upper corner of the screen, not the world
      return;
  }
  
  LogManager &lm = LogManager::getInstance();
}

void Lives::addLife(int lives_count) {
	lives += lives_count;
}

int Lives::eventHandler(Event *e) {
	if (e->getType() == STEP_EVENT)
	{
		WorldManager &wm = WorldManager::getInstance();
		pos.setX(wm.getView().getCorner().getX());
		pos.setY(wm.getView().getCorner().getY() + 1);
	}
}


