// Cian Rice

#include "Score.h"

using namespace std;

Score::Score(Position hud_pos) {
	altitude = 2;
	setType("Score HUD");
	setSolid(false);	
	LogManager &lm = LogManager::getInstance();
	lm.writeLog("Initiliazing Score HUD");
	WorldManager &wm = WorldManager::getInstance();
	setPosition(hud_pos);
	lm.writeLog("HUD X: = %d", pos.getX());
	lm.writeLog("HUD Y: = %d", pos.getY());
	wm.registerInterest(this, STEP_EVENT);

}

Score::~Score() {
	WorldManager &wm = WorldManager::getInstance();
	wm.registerInterest(this, STEP_EVENT);
}

// Code based upon Brian Seney's Saucer Shoot Score Code
void Score::draw() {
  ostringstream hud(ostringstream::out);
  hud << "Score: ";
  hud << score;
  GraphicsManager &graph_mgr = GraphicsManager::getInstance();
  
  for(int i = 0; i < hud.str().size(); i++){
    if(graph_mgr.drawCh(Position(pos.getX() + i, 
		 pos.getY()), hud.str()[i]) == 1) // modified so that it displays in the upper corner of the screen, not the world
      return;
  }
  
  LogManager &lm = LogManager::getInstance();
}

void Score::addPoints(int score_count) {
	score += score_count;
}

int Score::eventHandler(Event *e) {
	if (e->getType() == STEP_EVENT)
	{
		WorldManager &wm = WorldManager::getInstance();
		pos.setX(wm.getView().getCorner().getX());
		pos.setY(wm.getView().getCorner().getY());
	}
}


