///
/// A 2-d bounding box
///

#ifndef __BOX_H__
#define __BOX_H__

#include "Position.h"

class Box {

 protected:
  Position corner;   		///< Upper left corner of box.
  int horizontal;               ///< Horizontal dimension.
  int vertical;			///< Vertical dimension.

 public:
  /// Create a box with an upper-left corner, horiz and vert sizes.
  Box(Position init_corner, int init_horizontal, int init_vertical);

  /// Create a box with (0,0) for the corner, and 0 for horiz and vert.
  Box();
  ~Box();

  Position getCorner();
  void setCorner(Position new_corner);
  int getHorizontal();
  void setHorizontal(int new_horizontal);
  int getVertical();
  void setVertical(int new_vertical);
};

#endif //__BOX_H__

