///
/// The clock, for timing the game loop
///

#ifndef __CLOCK_H__
#define __CLOCK_H__

#include <time.h>

class Clock {

 protected:
  struct timespec prev_ts;

 public:
  /// Set the clock for initial call.
  Clock();

  /// \brief Return time difference since last call between current 
  /// time and prevtime.  This should be called once per frame time.
  /// Units are microseconds.
  long int delta(void);

};

#endif // __CLOCK_H__
