///
/// A "mouse" event
///

#ifndef __EVENT_MOUSE_H__
#define __EVENT_MOUSE_H__

#include "Event.h"

#define MOUSE_EVENT "mouse"

/// The set of mouse actions recognized by Dragonfly.
enum MouseActionList {
  LEFT_BUTTON_CLICK,
  LEFT_BUTTON_DOUBLECLICK,
  RIGHT_BUTTON_CLICK,
  RIGHT_BUTTON_DOUBLECLICK,
  UNDEFINED
};

class EventMouse : public Event {

 protected:
  enum MouseActionList mouse_action; ///< Stores the mouse action.
  int mouse_x;			     ///< The mouse x coordinate.
  int mouse_y;                       ///< The mouse y coordinate.

 public:
  EventMouse();

  /// Load the mouse event's action.
  void setMouseAction(enum MouseActionList new_mouse_action);

  /// Get the mouse event's action.
  enum MouseActionList getMouseAction();

  /// Set the mouse event's x coordinate.
  void setMouseX(int new_x);

  /// Set the mouse event's y coordinate.
  void setMouseY(int new_y);

  /// Get the mouse event's x coordinate.
  int getMouseX();

  /// Get the mouse event's y coordinate.
  int getMouseY();
};

#endif // __EVENT_MOUSE_H__
