///
/// An iterator for GameObjectLists
///

#ifndef __GAME_OBJECT_LIST_ITERATOR_H__
#define __GAME_OBJECT_LIST_ITERATOR_H__

#include "GameObjectList.h"

class GameObjectList;

class GameObjectListIterator {

 private:
  GameObjectListIterator();	///< Iterator must be given list when created.

 protected:
  int index;			///< Index into list.
  const GameObjectList *p_list; ///< List iterating over.

 public:
  ~GameObjectListIterator();

  /// Create iterator, over indicated list.
  GameObjectListIterator(const GameObjectList *p_l);

  void first();			///< Set iterator to first item in list.
  void next();                  ///< Set iterator to next item in list.
  bool isDone();                ///< Return true if at end of list.

  /// Return pointer to current item in list, NULL if done/empty.
  GameObject *currentObject();     
};

#endif // __GAME_OBJECT_LIST_ITERATOR_H__
