///
/// The sprite
/// 

#ifndef __SPRITE_H__
#define __SPRITE_H__

#include <string>
#include "Frame.h"

using namespace std;

class Sprite {

 protected:
  int width;                    ///< Sprite width.
  int height;                   ///< Sprite height.
  int max_frame_count;		///< Maximum number of frames sprite can have.
  int frame_count;              ///< Actual number of frames sprite has.
  int color;			///< Optional color for entire sprite.
  Frame *frame;			///< Array of frames.
  string label;                 ///< Text label to identify sprite.
  Sprite();                     ///< Sprite constructor always has one arg.

 public:
  ~Sprite();
  Sprite(int max_frames);	///< Max frame count fixed upon creation.
  int getWidth();
  void setWidth(int new_width);
  int getHeight();
  void setHeight(int new_height);
  string getLabel();
  void setLabel(string new_label);
  int getColor();
  void setColor(int new_color);
  int getFrameCount();
  Frame getFrame(int frame_number);
  int addFrame(Frame new_frame);
};

#endif // __SPRITE_H__
